<?php
	/**************************************************************************\
	* ExpressoLivre - preferences                                              *
	* http://www.celepar.pr.gov.br                                             *
	* Written by Joseph Engo <jengo@phpgroupware.org>                          *
	* Modify by Joo Alfredo Knopik Junior <jakjr@celepar.pr.gov.br>           *
	* 																		   * 
	* --------------------------------------------                             *
	*  This program is free software; you can redistribute it and/or modify it *
	*  under the terms of the GNU General Public License as published by the   *
	*  Free Software Foundation; either version 2 of the License, or (at your  *
	*  option) any later version.                                              *
	\**************************************************************************/


	$GLOBALS['phpgw_info']['flags'] = array(
		'noheader'   => True,
		'nonavbar'   => True,
		'currentapp' => 'preferences'
	);

	include('../header.inc.php');

	if($_POST['cancel'])
	{
		$GLOBALS['phpgw']->redirect_link('/preferences/index.php');
		$GLOBALS['phpgw']->common->phpgw_exit();
	}

	if(!@is_object($GLOBALS['phpgw']->js))
	{
		$GLOBALS['phpgw']->js = CreateObject('phpgwapi.javascript');
	}
	$GLOBALS['phpgw']->js->validate_file('jscode','scripts','preferences');#diretorio, arquivo.js, aplicacao

	$GLOBALS['phpgw']->template->set_file(array(
		'form' => 'changepersonaldata.tpl'
	));

	$GLOBALS['phpgw']->template->set_var('lang_commercial_telephonenumber',lang('Commercial Telephone number'));
	$GLOBALS['phpgw']->template->set_var('lang_ps_commercial_telephonenumber',
	lang('Observation') . ': ' . lang('This telephone number will apear in searches for your name, and it will be visible for all ExpressoLivre Users') . '.');
	$GLOBALS['phpgw']->template->set_var('lang_change',lang('Change'));
	$GLOBALS['phpgw']->template->set_var('lang_cancel',lang('Cancel'));
	$GLOBALS['phpgw']->template->set_var('form_action',$GLOBALS['phpgw']->link('/preferences/changepersonaldata.php'));

	/* Get telephone number from ldap or from post */
	$ldap_conn = $GLOBALS['phpgw']->common->ldapConnect();
	$result = ldap_search($ldap_conn, $GLOBALS['phpgw_info']['server']['ldap_context'], 'uid='.$GLOBALS['phpgw_info']['user']['account_lid'], array('telephonenumber'));
	$entrie = ldap_get_entries($ldap_conn, $result);
	$GLOBALS['phpgw']->template->set_var('telephonenumber',$_POST['telephonenumber'] ? $_POST['telephonenumber'] : $entrie[0]['telephonenumber'][0]);
	ldap_close($ldap_conn);

	if ($GLOBALS['phpgw_info']['server']['auth_type'] != 'ldap')
	{
		$GLOBALS['phpgw']->template->set_var('sql_message',lang('note: This feature is *exclusive* for ldap repository.'));
	}

	if ($_POST['change'])
	{
		if ($_POST['telephonenumber'] != $GLOBALS['phpgw_info']['user']['telephonenumber'])
		{
			$pattern = '/\([0-9]{2,3}\)[0-9]{4}-[0-9]{4}$/';
			if (!preg_match($pattern, $_POST['telephonenumber']))
			{
				$errors[] = lang('Format of telephone number is invalid.');
			}
			else
			{
				// Use LDAP Replication mode, if available
				if ( (!empty($GLOBALS['phpgw_info']['server']['ldap_master_host'])) &&
					 (!empty($GLOBALS['phpgw_info']['server']['ldap_master_root_dn'])) &&
				 	 (!empty($GLOBALS['phpgw_info']['server']['ldap_master_root_pw'])) )
				{
					$ldap_conn = $GLOBALS['phpgw']->common->ldapConnect(
												   $GLOBALS['phpgw_info']['server']['ldap_master_host'],
												   $GLOBALS['phpgw_info']['server']['ldap_master_root_dn'],
												   $GLOBALS['phpgw_info']['server']['ldap_master_root_pw']
												   );
				}
				else
				{
					$ldap_conn = $GLOBALS['phpgw']->common->ldapConnect();
				}
				
				$info['telephonenumber'] = $_POST['telephonenumber'];
				
				if ($GLOBALS['phpgw_info']['user']['telephonenumber'])
				{
					$result = @ldap_mod_replace($ldap_conn, $GLOBALS['phpgw_info']['user']['account_dn'], $info);
				}
				else
				{
					$result = @ldap_mod_add($ldap_conn, $GLOBALS['phpgw_info']['user']['account_dn'], $info);
				}
			}
			
			if(is_array($errors))
			{
				$GLOBALS['phpgw']->common->phpgw_header();
				echo parse_navbar();
				$GLOBALS['phpgw']->template->set_var('messages',$GLOBALS['phpgw']->common->error_list($errors));
				$GLOBALS['phpgw']->template->pfp('out','form');
				$GLOBALS['phpgw']->common->phpgw_exit(True);
			}
		}
		$GLOBALS['phpgw']->redirect_link('/preferences/index.php','cd=18');
	}
	else
	{
		$GLOBALS['phpgw_info']['flags']['app_header'] = lang('Change your Personal Data');
		$GLOBALS['phpgw']->common->phpgw_header();
		echo parse_navbar();

		$GLOBALS['phpgw']->template->pfp('out','form');
		$GLOBALS['phpgw']->common->phpgw_footer();
	}
?>
